#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityElevenSignCFG.h"
std::auto_ptr<M_ActivityElevenSignCFG> M_ActivityElevenSignCFG::msSingleton(nullptr);

int M_ActivityElevenSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityElevenSignCFGData* M_ActivityElevenSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityElevenSignCFGData>& M_ActivityElevenSignCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityElevenSignCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityElevenSignCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityElevenSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardQuantity = element->Attribute("RewardQuantity");
			std::vector<std::string> vecRewardQuantity;
			boost::split(vecRewardQuantity, RewardQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardQuantity[i].c_str(), &temp))
				{
					data.mRewardQuantity.push_back(temp);
				}
			}
		}
		{
			const char* Display = element->Attribute("Display");
			std::vector<std::string> vecDisplay;
			boost::split(vecDisplay, Display, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplay.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplay[i].c_str(), &temp))
				{
					data.mDisplay.push_back(temp);
				}
			}
		}
		{
			const char* DisplayQuantity = element->Attribute("DisplayQuantity");
			std::vector<std::string> vecDisplayQuantity;
			boost::split(vecDisplayQuantity, DisplayQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDisplayQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDisplayQuantity[i].c_str(), &temp))
				{
					data.mDisplayQuantity.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityElevenSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityElevenSignCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityElevenSignCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityElevenSignCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityElevenSignCFGData data;
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readVectorInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readVectorInt(L, "RewardQuantity", data.mRewardQuantity);
		LuaCfgHelper::readVectorInt(L, "Display", data.mDisplay);
		LuaCfgHelper::readVectorInt(L, "DisplayQuantity", data.mDisplayQuantity);
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityElevenSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityElevenSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityElevenSignCFG* M_ActivityElevenSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityElevenSignCFG());
	}
	return msSingleton.get();
}

void M_ActivityElevenSignCFG::Release()
{
	msSingleton.reset(nullptr);
}
